<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="org.pnyka.database.*, java.sql.*, org.pnyka.components.administrator.*, org.pnyka.components.registrar.*"%>
<%@page import="org.pnyka.util.*, java.util.Properties"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" href="css/forms_style.css" type="text/css"/>
        <title>BASIC OPERATIONS</title>
    </head>
    <body id="bd">
    <br><center>
    <%
    
    //retrieves the session created by this request
    session = request.getSession(false); 

    //if session is null or new, that means user hasn't loged in, then redirect to index (login) page
    if(session == null || session.isNew() == true)
        response.sendRedirect("index.jsp");

    //get parameters from previous page
    String button_num = request.getParameter("button_num");
    String usr = request.getParameter("username");
    String psw = request.getParameter("password");    
    
     if(usr == null || psw == null || button_num == null)
            response.sendRedirect("index.jsp");    
    
    try
    {
        if(button_num.equals("1"))//election catalog creation
        {
            ;
        }
        else if(button_num.equals("2"))//registrar activation
        {
           ;
        }
        else if(button_num.equals("3"))//activate Keyholders
        {
           ;
        }
        else if(button_num.equals("4"))//start tallying
        {
            Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
            Connection conn_local = Database.connectDatabase("DB_LOCAL_NAME", "DB_LOCAL_USERNAME", "DB_LOCAL_PASSWORD", "DB_LOCAL_HOST");
            PropertiesFiles pf = new PropertiesFiles();
            Properties properties = pf.ReadProperties("ea.properties");
            String ea_code = properties.getProperty("EA_CODE");       
            int valid_date_time = -1;

            try
            {
                valid_date_time = Validation.validateDateAndTime("tallier");     
                
                if(valid_date_time != 2 || DatabaseQueries.countRows(DatabaseQueries.selectAllFromTable(conn, "keyholders")) == 0 )
                {
                    if(valid_date_time != 2)
                        out.print("Voting is in process.");
                    else
                        out.print("Tallying cannot start.<br>Basic parameterization operations<br>have not been realized.");
                }
                else
                {
                    Statement stm = conn_local.createStatement();

                    ResultSet config_ballots = DatabaseQueries.selectFromTable(conn, "SELECT * FROM config_ballots WHERE vote_area IS NULL OR vote_area = "+ea_code+";");        
                    ResultSet config_candidates = null; 
                    
                    if(DatabaseQueries.countRows(DatabaseQueries.selectAllFromTable(conn_local, "tallier")) == 0)
                    {
                        if(DatabaseQueries.countRows(config_ballots) != 0)
                        {
                            while (config_ballots.next())
                            {
                                stm.execute("INSERT INTO config_ballots (ballot_id, ballot_description, candidate_num, is_white, is_invalid) VALUES ('" +config_ballots.getInt("ballot_id")+ "','" +config_ballots.getString("ballot_description")+ "','" +config_ballots.getInt("candidate_num")+ "','" +config_ballots.getBoolean("is_white")+ "','" +config_ballots.getBoolean("is_invalid")+ "')");
                                config_candidates = DatabaseQueries.selectFromTable(conn, "SELECT * FROM config_candidates WHERE ballot_id = "+config_ballots.getInt("ballot_id")+";");

                                while (config_candidates.next())
                                {
                                    stm.execute("INSERT INTO config_candidates (ballot_id, candidate_description, candidate_m) VALUES ('" +config_candidates.getInt("ballot_id")+ "','" +config_candidates.getString("candidate_description")+ "','" +config_candidates.getInt("candidate_m")+ "')");
                                }
                            }
                        }
                    }

                    int ret = BasicAdministrationOperations.startTallier();

                    if(ret == 1)
                        out.print("There was a problem during transaction with database.");
                    else if(ret == 2)
                    {
                        out.print("Final results have already been calculated been .");
                        %>
                        <br><a href='#' onclick="window.close(); parent.window.opener.location.href = 'results.jsp?username=<%=usr%>&password=<%=psw%>';">Results</a>
                        <%
                    }
                    else if(ret == 3)
                        out.print("Voting is in process.");
                    else if(ret == 0)
                    {
                        out.print("Final results have been calculated.");       
                        %>
                        <br><a href='#' onclick="window.close(); parent.window.opener.location.href = 'results.jsp?username=<%=usr%>&password=<%=psw%>';">Results</a>
                        <%
                    }
                    else if(ret == 4)
                        out.print("Not all parameters are defined.");
                }
            
            }
            catch(NullPointerException ex)
            {
                out.print("Tallying cannot start.<br>Basic parameterization operations have not been realized.");
            }
        }
        else if(button_num.equals("5"))//start Central registrar
        {
            int ret = BasicAdministrationOperations.RegistrarActivation();

            if(ret == 1)
                out.print("Local election catalog has already been defined.");                
            else if(ret == 2)
                out.print("Central election catalog has not been defined.");
            else if(ret == 0)
                out.print("Local election catalog is defined.");
            else if(ret == 3)
                out.print("There was a problem during transaction with database.");            
        }
        else if(button_num.equals("6"))//start local registrar
        {
            int ret = Registration.StartLocalRegistrar();

            if(ret == 1)// Election catalog does not exist
                out.print("Central election catalog has not been defined.");
            else if(ret == 2)
                out.print("Central registrar has not been started.");
            else if(ret == 3)
                out.print("There was a problem during transaction with database.");   
            else if(ret == 0)
               out.print("Local registrar is started.");
            else if(ret == 4)
               out.print("Local registrar has already been started.");
         }
    }
    catch(SQLException ex)
    {
        out.print(ex.toString());
    }
            
    %>
    
    <br><br><a><img onclick="window.close();" src='images/buttons/close.gif'/></a>
    </center>
    </body>
</html>
