package org.pnyka.database;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

/**
 *
 * @author nakou
 */
public class DatabaseQueries
{
    
   public static ResultSet selectAllFromTable(Connection conn, String tableName) throws SQLException
   {
       Statement sql = null;       
       ResultSet set = null;
       String sqlText; 
                       
       sql = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_UPDATABLE); //create a statement that we can use later
       sqlText = "SELECT * FROM " +tableName;
       set = sql.executeQuery(sqlText);//(sqlText);//Update(sqlText);                               
       
       return set;
   }       
   
   public static ResultSet selectFromTable(Connection conn, String sqlText) throws SQLException
   {             
       Statement sql = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_UPDATABLE); //create a statement that we can use later
       ResultSet rs = sql.executeQuery(sqlText);                             
       
       return rs;
   } 
   
   public static int countRows(ResultSet rs) throws SQLException
   {
       // select the number of rows in the table
       int rowCount = -1;
       // get the number of rows from the result set
       rs.last();
       rowCount = rs.getRow();
       rs.beforeFirst();
       
       return rowCount;
  }

  
}
