<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="org.pnyka.database.*, java.sql.*, org.pnyka.util.*, java.util.*"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
    <title>"PNYX" ELECTRONIC VOTING SYSTEM</title>
    <link rel="stylesheet" href="style.css" type="text/css"/>

    <script>
    function clear_form()
    {            
        document.check_voter_form.username.value = "";
        document.check_voter_form.password.value = "";
    }
    </script>
</head>

<%
    PropertiesFiles pf = new PropertiesFiles();
    Properties properties = pf.ReadProperties("ea.properties");
    String ea_code = properties.getProperty("EA_CODE");
    
    Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
    Connection conn_local = Database.connectDatabase("DB_LOCAL_NAME", "DB_LOCAL_USERNAME", "DB_LOCAL_PASSWORD", "DB_LOCAL_HOST");
    
    boolean exist_pki = false;
        
    try
    {
        ResultSet config_security_protocol = DatabaseQueries.selectAllFromTable(conn, "config_security_protocol");
        config_security_protocol.next();
        
        if(config_security_protocol.getBoolean("pki_locals_voters") == true)
            exist_pki = true;    
    }
    catch(SQLException ex){}
  
    int valid_date_time = Validation.validateDateAndTime("voter");
%>

    <body>    
	<div id="wrapper">
            <div id="header">
            <%
           
            if(valid_date_time == 0)
            {                    
                if(exist_pki == false)
                {
                    Statement stm = conn_local.createStatement();
                    String session_id = request.getSession().getId();

                    boolean executed = true;// 

                    try
                    {
                        ResultSet sessions = DatabaseQueries.selectFromTable(conn_local, "SELECT * FROM sessions WHERE session_id = '" +session_id + "'");
                        if(DatabaseQueries.countRows(sessions) == 1)
                        {
                            sessions.next();
                            session_id = sessions.getString("session_id");
                        }
                        else
                        {
                            int voter_id = -1;
                            Statement stm_central = conn.createStatement();
                            ResultSet seq = stm_central.executeQuery("SELECT max(voter_id) as voter_id FROM encrypted_votes");
                            
                            seq.next();
                            voter_id = seq.getInt("voter_id")+1;
                            
                            sessions = DatabaseQueries.selectFromTable(conn_local, "SELECT * FROM sessions WHERE voter_id = '" +voter_id + "'");
                            if(DatabaseQueries.countRows(sessions) == 0)
                                stm.executeUpdate("INSERT INTO sessions (session_id, voter_id) VALUES ('" +session_id + "', '" +voter_id+ "')");
                            else
                            {
                             
                                String  query = "UPDATE sessions " +
                                "SET session_id = '" +session_id+ "', voter_id = '" +voter_id+ "'  "+
                                "WHERE voter_id = '" +voter_id+ "' ";

                                stm.executeUpdate(query);
                            }
                                
                        }
                    }
                    catch(SQLException e)
                    {
                        executed = false;
                    }

                    if(executed == false)
                    {  
                       String url = "session_id="+session_id;
                       response.sendRedirect("FailurePage.jsp?message=1&"+url);           
                    }
                %>
                <div id="navigation"><br><br>
                    <ul>
                        <li><a href="CastBallot.jsp?session_id=<%=session_id%>">Submit Vote</a></li>
			<li><a href="BulletinBoard.jsp?session_id=<%=session_id%>">Bulletin Board</a></li>
                    </ul>
               </div>
                <img id="img" src="images/e-pnyka.gif" alt="logos"/>
                <%
                }
                else
                {                    
                %>
                <img id="img" src="images/e-pnyka.gif" alt="logos"/>
		<%
                }
            }
            else
            {              
            %>
                <img id="img" src="images/e-pnyka.gif" alt="logos"/>
            <%             
            }
            %>
	</div>
		
	<div id="content">
        <%  
        if(valid_date_time == 0)
        { 
            if(exist_pki == true)
            {
            %>
                <br><br>
                <form name="check_voter_form" action="valid_voter.jsp" method="POST">
                    <table id="login" cellpadding="15px" cellspacing="15px">
                        <tr>
                            <td align="left"><b>Username</b></td>
                            <td><input type="text" style="width:200px"  name="username" value="" size="15"  maxlength="15"/></td>
                        </tr>
                        <tr>
                             <td align="left"><b>Password</b></td>
                             <td><input type="password" style="width:200px" name="password" value="" size="10" maxlength="10"/></td>
                        </tr>
                        <tr>   
                            <td></td>
                            <td align="right">
                                <input type="button" name="exists" value="Clear" style="width:100px" onclick="clear_form()"/>
                                <input type="submit" name="exists" value="Login" style="width:100px"/>                            
                            </td>
                        </tr>                        
                     </table>
                 </form>

                <%
                }
                else
                {   
                    %>
                    <div id='Guidelines'>
                       <ul>
                         <br><b>Guidelines</b>:<br>
                         <li>In order to submit your vote, chose 'Submit Vote'.</li>    
                         <li>In order to see your encrypted vote, chose 'Bulletin Board'.</li>
                         <li>In order to see final voting results, chose 'Results'.</li>
                         <li>In order to logout, chose 'Logout'.</li>
                       </ul>                                                 
                    </div>    
                    <%
                }
        }
        else
        {
            out.print("<div id='message'>");
            if(valid_date_time == 1)
                out.print("<br><br><br><br>Voting has not started yet.<br><br>");
            else if (valid_date_time == 2)
                out.print("<br><br><br><br>Voting has finished. You cannot submit your vote.<br><br>");
            else if (valid_date_time == 1)    
                out.print("<br><br><br><br>Voting has not started yet.<br><br>");
            else if(valid_date_time == 2)
                out.print("<br><br><br><br>Voting has finished. You cannot submit your vote.<br><br>");
             out.print( "</div>");
        }                
    %>    
         </div>
          
          <div id="logos" align="center">
             <table>
                <tr>
                    <td><img src="images/gget_en.gif" alt="gget"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    <td><img src="images/egov.gif" alt="egov"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    <td><img src="images/expertnet.gif" alt="expertnet"/></td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    <td><img src="images/eulogo.gif" alt="eulogo"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                </tr>
             </table>
         </div>
         
         <div id="footer" align="right"><br>
	 2007 &copy; www.localea<%out.print(ea_code);%>.cti.gr   
         </div>
       </div>
    </body>
</html>
