<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="org.pnyka.database.*, org.pnyka.components.administrator.*, java.sql.*, java.util.*, java.lang.*"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" href="../css/forms_style.css"  type="text/css"/>  
        <title>STORE DATA</title>
    </head>
    
    <body id="bd"><center>
   
    <%      
    String form_name = request.getParameter("form_name");
    boolean ret = false;
    
    
    if(form_name.equals("centralEA"))
    {        
        String computer_name = request.getParameter("computer_name");
        String machine_ip = request.getParameter("machine_ip");
        String description = request.getParameter("description");
        String url = request.getParameter("url");
        String vote_area = request.getParameter("vote_area");       

        if(description.equals("") && vote_area.equals(""))
            ret = SystemInitialization.DefineCentralEA(computer_name, machine_ip, url, true, false);
        else if(description.equals("") && vote_area.equals("") == false)
            ret = SystemInitialization.DefineCentralEA(computer_name, machine_ip, url, vote_area, true, false);
        else if(description.equals("") == false && vote_area.equals(""))
            ret = SystemInitialization.DefineCentralEA(computer_name, machine_ip, url, true, false, description);
        else
            ret = SystemInitialization.DefineCentralEA(computer_name, machine_ip, url, vote_area, true, false, description);        
    }
    else if(form_name.equals("localEA"))
    {
        String computer_name = request.getParameter("computer_name");
        String machine_ip = request.getParameter("machine_ip");
        String description = request.getParameter("description");
        String url = request.getParameter("url");
        String vote_area = request.getParameter("vote_area");       

        if(description.equals("") && vote_area.equals(""))
            ret = SystemInitialization.DefineLocalEA(computer_name, machine_ip, url, false, true);
        else if(description.equals("") && vote_area.equals("") == false)
            ret = SystemInitialization.DefineLocalEA(computer_name, machine_ip, url, vote_area, false, true);
        else if(description.equals("") == false && vote_area.equals(""))
            ret = SystemInitialization.DefineLocalEA(computer_name, machine_ip, url, false, true, description);
        else
            ret = SystemInitialization.DefineLocalEA(computer_name, machine_ip, url, vote_area, false, true, description); 

    }
    else if(form_name.equals("keyholders"))
    {        
        String kh_name = request.getParameter("kh_name");
        String description = request.getParameter("description");
       
        if(description.equals(""))
            ret = SystemInitialization.DefineKeyholders(kh_name, null);
        else 
            ret = SystemInitialization.DefineKeyholders(kh_name, description);
    }
    else if(form_name.equals("date_time"))
    {
        //get request's parameters
        String starting_day = request.getParameter("starting_day");
        String starting_month = request.getParameter("starting_month");
        String starting_year = request.getParameter("starting_year");
        String starting_hour = request.getParameter("starting_hour")+":00:00";

        String stopping_day = request.getParameter("stopping_day");
        String stopping_month = request.getParameter("stopping_month");
        String stopping_year = request.getParameter("stopping_year");
        String stopping_hour = request.getParameter("stopping_hour")+":00:00";

        String start_date_concat = starting_year+"-"+starting_month+"-"+starting_day;        
        String stop_date_concat = stopping_year+"-"+stopping_month+"-"+stopping_day;

        //convert to sql time
        Time start_time_sql = Time.valueOf(starting_hour);
        Time stop_time_sql = Time.valueOf(stopping_hour);

        //convert to sql date
        java.sql.Date start_date_sql = java.sql.Date.valueOf(start_date_concat);
        java.sql.Date stop_date_sql =  java.sql.Date.valueOf(stop_date_concat);

        ret = SystemParameterization.DefineStartStopElection(start_date_sql, stop_date_sql, start_time_sql, stop_time_sql);
    }
    else if(form_name.equals("candidate"))
    {                
        String ballot_description, candidate_description, vote_area;
        int candidate_number, candidate_m;

        ballot_description = request.getParameter("ballot_description");
        candidate_number = Integer.parseInt(request.getParameter("candidate_number"));
        vote_area = request.getParameter("vote_area");   
        
        int[] candidates_m_arr = new int[candidate_number];//contains all candidates' m's of a certain ballot
        String[] candidates_description_arr = new String[candidate_number];//contains all candidates' descriptions of a certain ballot

        for (int i=1; i<= candidate_number; i++) 
        {
            candidate_description = request.getParameter("candidate_description"+i);
            candidate_m = Integer.parseInt(request.getParameter("candidate_m"+i));           

            candidates_description_arr[i-1] = candidate_description;
            candidates_m_arr[i-1] = candidate_m;
        }
        
        if(vote_area.equals("") == true)
            ret = SystemParameterization.DefineElectionProcess(ballot_description, candidate_number, false, false, null, candidates_description_arr, candidates_m_arr);
        else
            ret = SystemParameterization.DefineElectionProcess(ballot_description, candidate_number, false, false, vote_area, candidates_description_arr, candidates_m_arr);
    }
    else if(form_name.equals("protocol_params"))  
    {
        boolean zkp = true, signs = true, timestamp = true;

        if(request.getParameter("zkp") == null)
            zkp = false;
        if(request.getParameter("signs") == null)
            signs = false;
        if(request.getParameter("timestamp") == null)
            timestamp = false;         

        int key_length = Integer.parseInt(request.getParameter("key_length"));
        int threshold = Integer.parseInt(request.getParameter("threshold"));        

        ret = SystemParameterization.DefineProtocolParameters(zkp, signs, timestamp, key_length, threshold);
        //out.print(ret1+"<br>");
    }
    else if(form_name.equals("sec_level"))  
    {
        boolean pki_central_voters = false, pki_locals_voters = false, vpn_central_locals = false;        

        if(request.getParameter("sec_level1").equals("vpn"))
            vpn_central_locals = true;
        if(request.getParameter("sec_level2").equals("pki"))
            pki_locals_voters = true;

        ret = SystemParameterization.DefineSecurityLevel(pki_central_voters, pki_locals_voters, vpn_central_locals);     
    }
    else if(form_name.equals("vote_submition"))  
    {
       String file_el_catalog = request.getParameter("full_path");

       boolean one_vote = false, many_votes = false, ret2;

       if(request.getParameter("valid_votes").equals("one"))
           one_vote = true;
       else if(request.getParameter("valid_votes").equals("many"))
           many_votes = true;           

      if(file_el_catalog != null)
           ret = SystemParameterization.DefineElectionParticipation(file_el_catalog);
      else
           ret = SystemParameterization.DefineElectionParticipation(" ");

      ret2 = SystemParameterization.DefineValidVotes(one_vote, many_votes);

      ret = ret && ret2;      
    }
           
    if(ret == true)
        out.print("<br><br>Data stored<br><br>");
    else
        out.print("<br><br>There was a problem during transaction with database.<br><br>");
    %>
    
    <a><img onclick="window.close(); window.opener.location.reload();" src='../images/buttons/close.gif'/></a>
    
    </center></body>
</html>
