<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="org.pnyka.database.*, java.sql.*, org.pnyka.components.administrator.*, org.pnyka.components.registrar.*"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" href="css/forms_style.css" type="text/css"/>
        <title>BASIC OPERATIONS</title>
    </head>
    <body id="bd">
    <br><center>
    <%    
    //connection with central database and sql statement creation
    Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
    
    //retrieves the session created by this request
    session = request.getSession(false); 

    //if session is null or new, that means user hasn't loged in, then redirect to index (login) page
    if(session == null || session.isNew() == true)
        response.sendRedirect("index.jsp");

    //get parameters from previous page
    String button_num = request.getParameter("button_num");
    String usr = request.getParameter("username");
    String psw = request.getParameter("password");    
    
     if(usr == null || psw == null || button_num == null)
            response.sendRedirect("index.jsp");    
    
    if(button_num.equals("1"))//election catalog creation
    {
        int ret = BasicAdministrationOperations.CreateCentralElectionCatalog();    
                 
        if(ret == 1)// Election catalog does not exist
            out.print("Election catalog file has not been defined");
        else if(ret == 2)//There is no registration for local EA
            out.print("There is no registration for one of<br>election authorities you have defined.<br>" +
                      "Correct the file or insert the election authority.");
        else if(ret == 3)
            out.print("There was a problem during transaction with database.");
        else if(ret == 4)
            out.print("Election catalog has already been defined.");
        else if(ret == 0)
            out.print("Election catalog is created.");
        else if(ret == 5)
            out.print("Election catalog path not found.");
        
    }
    else if(button_num.equals("2"))//registrar activation
    {
        int ret = Registration.StartCentralRegistrar();
        
        if(ret == 1)
            out.print("Election catalog file is not defined.");
        else if(ret == 2)
            out.print("There was a problem during transaction with database.");
        else if(ret == 3)
            out.print("Central registrar has been activated.<br>Local registrars must be activated.");
        else if(ret == 0)
            out.print("Central registrar has been started.");
        else if(ret == 5)
            out.print("There is an error<br> in election catalog file.");
        else if(ret == 6)
            out.print("Election catalog has not been created.");
        else if(ret == 7)
            out.print("Central registrar has already been created.");
    }
    else if(button_num.equals("3"))//activate Keyholders
    {
        if(DatabaseQueries.countRows(DatabaseQueries.selectAllFromTable(conn, "keyholders")) == 0)
            out.print("Keyholders are not defined.");
        else
        {
            int ret = BasicAdministrationOperations.activateKeyholders();

            if(ret == 1)
                out.print("Keyholders are activated.");
            else if(ret == 2)//There is no registration for local EA
                out.print("Keyholders have already been activated.");
            else if(ret == 3)
                out.print("There was a problem during transaction with database.");
        }
    }
    else if(button_num.equals("4"))//start tallying
    {
        int ret = BasicAdministrationOperations.startTallier();
        
        if(ret == 1)
            out.print("There was a problem during transaction with database.");
        else if(ret == 2)
            out.print("Final results have already been computed.");
        else if(ret == 3)
            out.print("Voting is in process.");
        else if(ret == 0)
        {
            out.print("Results computed.");         
            %>
            <br><a href='#' onclick="window.close(); parent.window.opener.location.href = 'results.jsp?username=<%=usr%>&password=<%=psw%>';">Results</a>
            <%
        }
        else if(ret == 4)
            out.print("Not all parameters are defined.");
    }               
    %>
    
    <br><br><a><img onclick="window.close();" src='images/buttons/close.gif'/></a>
    </center>
    </body>
</html>
