<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="org.pnyka.database.*, java.sql.*, java.math.*, java.lang.*"%>
<%@page import="org.pnyka.util.*, java.util.*"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>"PNYX" ELECTRONIC VOTING SYSTEM</title>
        <link rel="stylesheet" href="style.css" type="text/css"/>
    </head>
    <body>
        <%
         PropertiesFiles pf = new PropertiesFiles();
         Properties properties = pf.ReadProperties("ea.properties");
         String ea_code = properties.getProperty("EA_CODE");        
        
         Connection conn_local = Database.connectDatabase("DB_LOCAL_NAME", "DB_LOCAL_USERNAME", "DB_LOCAL_PASSWORD", "DB_LOCAL_HOST");
         String session_id = request.getParameter("session_id");
         int count_sessions = 0;
         ResultSet ses = null;
                
         if(session_id !=null)
         {
                ses = DatabaseQueries.selectFromTable(conn_local, "SELECT * FROM sessions WHERE session_id = '" +session_id+ "' ");
                count_sessions = DatabaseQueries.countRows(ses);
         }
        
        %>
        
	<div id="wrapper">
            <div id="header">
                <div id="navigation"><br><br>
                    <ul>
                        <li><a href='BulletinBoard.jsp?session_id=<%=session_id%>'>Bulletin Board</a></li>
                        <li><a href='Results.jsp?session_id=<%=session_id%>'>Results</a></li>
                        <li><a href="Logout.jsp?session_id=<%=session_id%>">Logout</a></li>
                    </ul>
		</div>             
		<img id="img" src="images/e-pnyka.gif" alt="logos"/>
            </div>
		
	    <div id="content">
            <%
                   
                boolean one_vote = false;//polles 'h mia psifos
                                
                String ident_num = "";
                int voter_id = -1;
                
               if(session_id !=null && count_sessions == 1)
               {                                           
                    ResultSet  ballots = null, candidates_per_ballot = null,  config_elections = null;
       
                    Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
                                        
                    try
                    {
                        ballots = DatabaseQueries.selectAllFromTable(conn, "config_ballots");
                        config_elections = DatabaseQueries.selectAllFromTable(conn, "config_elections");
                        config_elections.next();
                        one_vote = config_elections.getBoolean("one_vote");                                   
                   
                        %>             
                      <center>
                          <form name="ballot_form" action = 'encrypt_choice.jsp?session_id=<%=session_id%>' onsubmit="return validate();" method = 'POST'>
                                <table id="ballot" cellpadding="10px" cellspacing="7px">
                                        <%
                                        while (ballots.next()) 
                                        { 
                                        candidates_per_ballot = DatabaseQueries.selectFromTable(conn, "SELECT candidate_description, candidate_m FROM config_candidates WHERE ballot_id = '" +ballots.getInt("ballot_id")+ "' ORDER BY candidate_id ");        
                                        %>
                                        <th>
                                            <%
                                            out.print("<br>"+ballots.getString("ballot_description")+"<br><br>");
                                            %>
                                        </th>
                                        <%
                                        candidates_per_ballot.beforeFirst();
                                        while (candidates_per_ballot.next()) 
                                        {
                                        %>     
                                        <tr>
                                            <td>
                                                <INPUT type = 'checkbox' name='choice' value= "<%=candidates_per_ballot.getInt("candidate_m")%>">
                                                <%out.print(candidates_per_ballot.getString("candidate_description"));%> 
                                            </td>
                                        </tr>
                                        <%
                                        }
                                        } 
                                        
                                        }  
                                        catch(SQLException ex)
                                        {
                                        String url = "session_id="+session_id;
                                        response.sendRedirect("FailurePage.jsp?message=1&"+url);
                                        }                    
                                        
                                        %>              <tr>
                                            <td align="center">
                                                <br><input type='submit' value='Submit Vote' name='submit'/>
                                            </td>
                                        </tr>
                                </table>
                            </form>
                        </center>                          
                    
                <%
               }                
               else
               {
                    String url = "session_id="+session_id;
                    response.sendRedirect("FailurePage.jsp?message=1&"+url);
               }
                    
                %>                    
	    </div>
            
            <div id="logos" align="center">
             <table>
                <tr>
                    <td><img src="images/gget_en.gif" alt="gget"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    <td><img src="images/egov.gif" alt="egov"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    <td><img src="images/expertnet.gif" alt="expertnet"/></td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    <td><img src="images/eulogo.gif" alt="eulogo"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                </tr>
             </table>
            </div>
            
            <div id="footer" align="right"><br/>
            2007 &copy; www.localea<%out.print(ea_code);%>.cti.gr         
            </div>                     
	</div>       

        <script language="javascript">
        function validate()//check if voter clicked one box
        {
            var one_vote = "<%=one_vote%>";

            var checkbox_choices = 0;
            var counter;
            
            for (counter = 0; counter < document.ballot_form.choice.length; counter++)
            {
                if (document.ballot_form.choice[counter].checked)
                {
                    checkbox_choices = checkbox_choices + 1;
                }
            
            }
                                    
            if (checkbox_choices == 1)
                return true;
            
            if (checkbox_choices > 1 || checkbox_choices == 0)
            {
                alert('You must chose only one choice.');
                return false;
            }
            
                      
         }
         </script>
        
</body>
</html>
