<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="org.pnyka.database.*, java.sql.*, java.math.*, java.util.*, org.pnyka.components.core.keyholder.*, org.bouncycastle.crypto.params.*, org.pnyka.cryptolib.crypto.Parameters"%>
<%@page import="org.pnyka.util.*, org.pnyka.cryptolib.crypto.CipherText, org.pnyka.cryptolib.math.*, org.pnyka.cryptolib.crypto.PlainText, org.pnyka.components.core.votemanager.*, java.lang.Integer" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>"PNYX" ELECTRONIC VOTING SYSTEM</title>
        <link rel="stylesheet" href="style.css" type="text/css"/>
    </head>
    
    <body> 
   
    <%
    PropertiesFiles pf = new PropertiesFiles();
    Properties properties = pf.ReadProperties("ea.properties");
    String ea_code = properties.getProperty("EA_CODE");
    
    Connection conn_local = Database.connectDatabase("DB_LOCAL_NAME", "DB_LOCAL_USERNAME", "DB_LOCAL_PASSWORD", "DB_LOCAL_HOST");
    String session_id = request.getParameter("session_id");
    int count_sessions = 0;
       
    ResultSet ses = null;
    if(session_id !=null)
    {
        ses = DatabaseQueries.selectFromTable(conn_local, "SELECT * FROM sessions WHERE session_id = '" +session_id+ "' ");
        count_sessions = DatabaseQueries.countRows(ses);
    }
    
    %>
        
     <div id='wrapper'>
       <div id='header'>
         <div id='navigation'><br><br>
               <ul>
                   <li><a href="CastBallot.jsp?session_id=<%=session_id%>">Submit Vote</a></li>
                   <li><a href='BulletinBoard.jsp?session_id=<%=session_id%>'>Bulletin Board</a></li>
                   <li><a href='Logout.jsp?session_id=<%=session_id%>'>Logout</a></li>
               </ul>                           
         </div>
         <img id="img" src='images/e-pnyka.gif' alt='logos'/>    
        </div>
            
       <div id='content'>
       <%   
       
       ResultSet params = null, choices = null;
       Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
        
       ElGamalParameters prm = null;
       ElGamalPublicKeyParameters pubKeyParams = null;
       int number_of_choices = 0;
       String[] choice  = request.getParameterValues("choice");
       int vectorOfVotes[] = null, vectorOfChoices[] = null;
       
       if(session_id !=null && count_sessions == 1)
       {      
            ses.next();
            int voter_id = ses.getInt("voter_id");//Integer.valueOf(request.getParameter("voter_id")).intValue(); 
            String ident_num = ses.getString("ident_num");
                  
            if(ident_num == null)
                ident_num = String.valueOf(ses.getInt("voter_id"));
                
            try
            {               
                params = DatabaseQueries.selectAllFromTable(conn, "parameters");

                params.next();
                prm = new ElGamalParameters(((BigDecimal)params.getObject("parameter_p")).toBigInteger(), ((BigDecimal)params.getObject("parameter_g")).toBigInteger());

                pubKeyParams = new ElGamalPublicKeyParameters(((BigDecimal)params.getObject("public_key")).toBigInteger(), prm);

                choices = DatabaseQueries.selectFromTable(conn, "SELECT * FROM config_candidates ORDER BY candidate_id");//oles oi dynates epiloges
                number_of_choices = DatabaseQueries.countRows(choices);

                vectorOfVotes = new int[number_of_choices];

                for(int i = 0; i<vectorOfVotes.length; i++)
                {
                   vectorOfVotes[i] = 1;
                }

                       vectorOfChoices = new int[number_of_choices];

                while(choices.next())
                {
                    vectorOfChoices[choices.getRow()-1] = choices.getInt("candidate_m");
                } 

                for(int i=0; i<vectorOfVotes.length; i++)
                {
                    for(int j=0; j<choice.length; j++)
                    {   
                        if((new Integer(choice[j])).intValue() == vectorOfChoices[i])
                            vectorOfVotes[i] = (new Integer(choice[j])).intValue();
                    }
                }
            } 
            catch (SQLException e){}
               
            CipherText[] vectorOfEncryptedVotes = new CipherText[vectorOfVotes.length];
             
            for(int i = 0; i<vectorOfVotes.length; i++)
            {
                vectorOfEncryptedVotes[i] = CipherText.elGamalEncrypt(new PlainText(BigInteger.valueOf(vectorOfVotes[i])), pubKeyParams);
            }
        
            VoteManager vm = new VoteManager();
            boolean stored = vm.PublishVote(voter_id, ident_num, vectorOfEncryptedVotes);
            
            if(stored == true)
                out.println ("<div id='message'><br><br>Your vote has been encrypted and stored.<br>" +
                             "In order to see your encrypted vote, visit the Bulletin Board.<br><br><br><br><br><br></div>");
            else
                out.println ("<div id='message'><br><br>There was a problem during transaction with the system.<br> Please vote again.<br><br><br><br><br><br></div>");
        }
        else
        {
            String url = "session_id="+session_id;
            response.sendRedirect("FailurePage.jsp?message=1&"+url);
        }
              
      %>
     
      </div>
      
      <div id="logos" align="center">
         <table>
           <tr>
              <td><img src="images/gget_en.gif" alt="gget"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
              <td><img src="images/egov.gif" alt="egov"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
              <td><img src="images/expertnet.gif" alt="expertnet"/></td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
              <td><img src="images/eulogo.gif" alt="eulogo"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
           </tr>
         </table>
      </div>

      <div id='footer'></br>
      2007 &copy; www.localea<%out.print(ea_code);%>.cti.gr
      </div>
   </div>
     
  </body>
</html>
