<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="org.pnyka.database.*, java.sql.*"%>
<%@page import="org.pnyka.util.*, java.util.*"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>"PNYX" ELECTRONIC VOTING SYSTEM</title>
        <link rel="stylesheet" href="style.css" type="text/css"/>              
    </head>
    <% String session_id = null; %>
    <body onbeforeunload="HandleOnClose(event)">
     
    <%
        PropertiesFiles pf = new PropertiesFiles();
        Properties properties = pf.ReadProperties("ea.properties");
        String ea_code = properties.getProperty("EA_CODE");
        
        boolean visited = false;
        
        String usr = request.getParameter("username");
        String psw = request.getParameter("password");
        
        if(usr == null || psw == null)
            response.sendRedirect("index.jsp");
            
        int voter_id = -1;
        String ident_num = null;
        String username = null;
               
	ResultSet rs = null, config_elections = null;
        int rowCount = -1;
        
        Connection conn_local = Database.connectDatabase("DB_LOCAL_NAME", "DB_LOCAL_USERNAME", "DB_LOCAL_PASSWORD", "DB_LOCAL_HOST");
              
        try
        {
            // Prepare a statement to select a record
            String selectStatement = "SELECT * FROM voter_credentials WHERE username = ? AND password = ?";
            PreparedStatement prepStmt = conn_local.prepareStatement(selectStatement, ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_UPDATABLE);
            prepStmt.setString(1, usr);
            prepStmt.setString(2, psw);
            rs = prepStmt.executeQuery();

            rowCount = DatabaseQueries.countRows(rs);
            if(rowCount == 1 )
            {
                rs.next();
                voter_id = rs.getInt("voter_id");
                ident_num = rs.getString("ident_num");
                username = rs.getString("username");
            }
                   
        }
        catch(SQLException e){}
       
        if(rowCount == 1 )
        { 
            Statement stm = conn_local.createStatement();
            session_id = request.getSession().getId();
            
            boolean executed = true;// 
            
            try
            {
                ResultSet sessions = DatabaseQueries.selectFromTable(conn_local, "SELECT * FROM sessions WHERE voter_id = '" +voter_id + "' AND ident_num = '" +ident_num + "' ");
                if(DatabaseQueries.countRows(sessions) == 1)
                {
                    sessions.next();
                    session_id = sessions.getString("session_id");
                            
                }
                else
                    stm.executeUpdate("INSERT INTO sessions (session_id, voter_id, ident_num) VALUES ('" +session_id + "', '" +voter_id + "', '" +ident_num + "')");
            }
            catch(SQLException e)
            {
                executed = false;
            }
            
            if(executed == false)
            {  
               String url = "session_id="+session_id;
               response.sendRedirect("FailurePage.jsp?message=1&"+url);           
            }
    %>
        
     <div id='wrapper'>
       <div id='header'>
         <div id='navigation'><br><br>
              <ul>
                   <li><a href='CastBallot.jsp?session_id=<%=session_id%>'>Submit Vote</a></li>
                   <li><a href='BulletinBoard.jsp?session_id=<%=session_id%>'>Bulletin Board</a></li>
                   <li><a href='Results.jsp?session_id=<%=session_id%>'>Results</a></li>
                   <li><a href='Logout.jsp?session_id=<%=session_id%>'>Logout</a></li>
              </ul>                           
         </div>
         <img id="img" src='images/e-pnyka.gif' alt='logos'/>    
        </div>
            
      
        <div id='content'><br>
            <div id='message'>Your ID is: <b><%=ident_num%></b></div><br>
             <div id='guidelines'>
               <ul>
                 <br><b>Guidelines</b>:<br>
                 <li>In order to submit your vote, chose 'Submit Vote'.</li>    
                 <li>In order to see your encrypted vote, chose 'Bulletin Board'.</li>
                 <li>In order to see final voting results, chose 'Results'.</li>
                 <li>In order to logout, chose 'Logout'.</li>
               </ul>                                                 
             </div>             
           
        </div>
          
        <div id="logos" align="center">
             <table>
                <tr>
                    <td><img src="images/gget_en.gif" alt="gget"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    <td><img src="images/egov.gif" alt="egov"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    <td><img src="images/expertnet.gif" alt="expertnet"/></td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    <td><img src="images/eulogo.gif" alt="eulogo"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                </tr>
             </table>
         </div>
        
        <div id='footer'><br>
        2007 &copy; www.localea<%out.print(ea_code);%>.cti.gr
        </div>
            
     </div>
     <%
        }
        else if(rowCount != 1)
        {
      %>
         <div id='wrapper'>
            <div id='header'>
                <img id="img" src='images/e-pnyka.gif' alt='logos'/>
            </div>

            <div id='content'>
                <div id='message'>
                <br><br><br><br>You do not have access rights to the system.<br>
                <a href='index.jsp'>Try again.</a>
                </div>                
            </div>
            
          <div id="logos" align="center">
             <table>
                <tr>
                    <td><img src="images/gget_en.gif" alt="gget"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    <td><img src="images/egov.gif" alt="egov"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    <td><img src="images/expertnet.gif" alt="expertnet"/></td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    <td><img src="images/eulogo.gif" alt="eulogo"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                </tr>
             </table>
         </div>

         <div id='footer'><br>
         2007 &copy; www.localea<%out.print(ea_code);%>.cti.gr
         </div>
            
        </div>
        <%
        }
        %> 
      
    </body>
</html>
