package org.pnyka.timestamper;

import org.bouncycastle.crypto.digests.MD5Digest;

public class MessageDigest
{
    static String byteArrayToHexString(byte in[])
    {
        byte ch = 0x00;
        int i = 0; 
        if (in == null || in.length <= 0)
            return null;

        String pseudo[] = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F"};
        StringBuffer out = new StringBuffer(in.length * 2);

        while (i < in.length) 
        {
            ch = (byte) (in[i] & 0xF0); // Strip off  high nibble
            ch = (byte) (ch >>> 4);     // shift the bits down
            ch = (byte) (ch & 0x0F);    // must do this is high order bit is on!
            out.append(pseudo[ (int) ch]); // convert the nibble to a String Character
            ch = (byte) (in[i] & 0x0F); // Strip off  low nibble 
            out.append(pseudo[ (int) ch]); // convert the nibble to a String Character
            i++;
        }
        String rslt = new String(out);
        return rslt;
    }   
    
    public static byte[] HashValue(byte[] in)
    {
        MD5Digest md = new MD5Digest();
        byte[] digest = new byte[16];
        //System.out.println(" length   "+md.getDigestSize());
        
        md.reset();
        md.update(in, 0, in.length);
        int l = md.doFinal(digest, 0); 
        
        //BigInteger hashValue = new BigInteger(digest);
        
        return digest;
    }    
    
    /*public static void main(String[] args)
    {
        byte[] digest = HashValue("asdf".getBytes());
        String s = byteArrayToHexString(digest);
        System.out.println(s);
        System.out.println(new BigInteger("asdf".getBytes()));
    }*/
    
}
