package org.pnyka.util;

import java.sql.Connection;
import java.sql.Date;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Time;
import java.text.DateFormat;
import org.pnyka.database.Database;
import org.pnyka.database.DatabaseQueries;

public class Validation
{
    public static int validateDateAndTime(String voterOrTallier)
    {
      Date starting_date = null, stopping_date = null, current_date = null;  
      Time starting_time = null, stopping_time = null, current_time = null;
      java.util.Date dt = new java.util.Date();
      
      Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
        
      try
      {
        ResultSet config_elections = DatabaseQueries.selectAllFromTable(conn, "config_elections");
        config_elections.next();
        
        starting_time = config_elections.getTime("starting_time");
        stopping_time = config_elections.getTime("stopping_time");
        starting_date = config_elections.getDate("starting_date");
        stopping_date = config_elections.getDate("stopping_date");
                            
      }
      catch(SQLException e){}
      
          
      String current_time_str = DateFormat.getTimeInstance().format(dt);

      String[] current_time_str_split = current_time_str.split(" ");
           
      if(current_time_str_split.length == 2 && (current_time_str_split[1].equals("??") || current_time_str_split[1].equals("Π?")
                                             || current_time_str_split[1].equals("PM") || current_time_str_split[1].equals("AM")
                                             || current_time_str_split[1].equals("pm") || current_time_str_split[1].equals("am")) )
      {
            if(current_time_str_split[1].equals("AM") || current_time_str_split[1].equals("am") || current_time_str_split[1].equals("Π?") || current_time_str_split[1].equals("πμ"))
            {
                current_time = Time.valueOf(current_time_str_split[0]);
                //System.out.println("Current time if: "+current_time);
            }
            else if(current_time_str_split[1].equals("PM") || current_time_str_split[1].equals("pm") || current_time_str_split[1].equals("??") || current_time_str_split[1].equals("μμ"))
            {
                int hours = Integer.parseInt(current_time_str_split[0].split(":")[0]);
                if(hours == 12)
                    current_time = Time.valueOf(current_time_str_split[0]);
                else 
                {
                    String[] tm = current_time_str_split[0].split(":");
                    hours = hours+12;
                    String ct = String.valueOf(hours);
                    
                    for(int i=1; i<tm.length;i++)
                    {
                        ct = ct+":"+tm[i];
                    }
                    
                    current_time = Time.valueOf(ct);
                }
            }
            
      }
      else if(current_time_str_split.length == 1)
         current_time = Time.valueOf(current_time_str_split[0]);
      else
         System.out.println("Unknown time format");
      
      
      current_date = new Date(dt.getTime());
      String current_date_str = current_date.toString();
      current_date = Date.valueOf(current_date_str);
              
      int error_case = -1;
      if(voterOrTallier.equals("voter") == true)
      {
          if(current_date.compareTo(starting_date)>=0 && current_date.compareTo(stopping_date)<=0 &&
             current_time.compareTo(starting_time)>=0 && current_time.compareTo(stopping_time)<=0 )
              error_case = 0;
          else if(current_date.before(starting_date) == true)
              error_case = 1; // h psifoforia den exei ksekinisei
          else if(current_date.after(stopping_date) == true)
              error_case = 2;  // h psifoforia exei teleiwsei
          else if(current_date.compareTo(starting_date)>=0 && current_date.compareTo(stopping_date)<=0)
          {
              if(current_time.compareTo(starting_time)<0)
                  error_case = 1;// h psifoforia den exei ksekinisei
              else if(current_time.compareTo(stopping_time) > 0)
                  error_case = 2; // h psifoforia exei teleiwsei
          }
          else if(current_date.compareTo(stopping_date) == 0)
          {
              if(current_time.before(starting_time) == true)
                  error_case = 1;
              else if(current_time.after(stopping_time) == true)
                  error_case = 2;          
          }
      }
      else if(voterOrTallier.equals("tallier") == true)
      {
         if(current_date.compareTo(stopping_date)>0 || (current_date.compareTo(stopping_date) >=0 && current_time.after(stopping_time) == true))
             error_case = 2;
      }
      return error_case;
      
    }
    
    public static void main (String[] args)
    {
        validateDateAndTime("tallier");
    }
    
 }