<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="org.pnyka.database.*, java.sql.*"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
    <title>"PNYX" SYSTEM ADMINISTRATION</title>
    <link rel="stylesheet" href="css/style_admin.css" type="text/css"/>    
</head>

    <body onload="loadInnerDiv(1)">    
	<div id="wrapper">	
            <div id="header">                             
            <h1><img id="img" src="images/e-pnyka.gif" title="logos"/></h1>
            </div>
            
            <div id="content">   
            <% 
            //retrieves the session created by this request
            session = request.getSession(false); 
            
            //if session is null or new, that means user hasn't loged in, then redirect to index (login) page
            if(session == null || session.isNew() == true)
                response.sendRedirect("index.jsp");
       
            //get parameters from previous page
            String usr = request.getParameter("username");
            String psw = request.getParameter("password");
        
            Connection conn = null;//database connection
            ResultSet administrator = null;
            
            try
            {
                //connection with central database
                conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
                //search database for the given username/password
                //Prepare a statement to select a record
                String selectStatement = "SELECT * FROM administrator WHERE usr = ? AND psw = ?";
                PreparedStatement prepStmt = conn.prepareStatement(selectStatement, ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_UPDATABLE);
                prepStmt.setString(1, usr);
                prepStmt.setString(2, psw);
                administrator = prepStmt.executeQuery();   
                
                //if there isn't an administrator with the given username/password, there is no entrance permission
                if(DatabaseQueries.countRows(administrator) != 1)
                     out.print("<div id='message'><br><br><br>You do not have access rights to the system.</div>");
                else
                {
                    %>
                    <table border='0' cellspacing='10px' width='670'>
                      <tr>
                        <td width='200'>
                            <div class='buttonscontainer'><div class='buttons'>                        
                            <a href='#' onclick='loadInnerDiv(1);'>Initialization</a>
                            <a href='#' onclick='loadInnerDiv(2);'>Parameterization</a>
                            <a href='#' onclick='loadInnerDiv(3);'>Basic operations</a>
                            </div></div>
                        </td>                        
                        <td width='470' height='330'>
                            <div id='innerdiv'><br></div>
                        </td>
                      </tr>
                      <tr>
                          <td colspan="2"><div id='footnote'>
                             <%
                              out.print("*In case you use the system for first time," +
                              " we recommend you change username and password." +
                              "&nbsp;&nbsp;<a href='change_credentials_form.jsp?username="+usr+"&password="+psw+"'>Change</a>");
                             %> 
                          </td></div>
                      </tr>                      
                    </table>
                    
                    <%                    
                }
            }
            catch (SQLException e1)
            {
                out.print( e1.toString()+"<br>");
                out.print("<div id='message'>There was a problem during transaction with database.</div>");
            }
            catch (NullPointerException e2)
            {
                out.print( e2.toString()+"<br>");
                out.print("<div id='message'>There was a problem during transaction with database.</div>");
            }
            
            %>   
                
            </div>
                    
            <div id="logos" align="center">
                <table>
                    <tr>
                        <td><img src="images/gget.gif" title="gget"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                        <td><img src="images/egov.gif" title="egov"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                        <td><img src="images/expertnet.gif" title="expertnet"/></td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                        <td><img src="images/eulogo.gif" title="eulogo"/><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    </tr>
                </table>
            </div>
                
            <div id="footer"><br>
            2007 &copy; System Administrator    
            </div>
	</div>        

        <script>

        function loadCentralEA()
        {
            if(navigator.appName == "Microsoft Internet Explorer")
                loadIframe('formframe', 'central_ea.jsp');
            else
                document.getElementById('formframe').src = 'central_ea.jsp';
        }

        function loadLocalEA()
        {
            if(navigator.appName == "Microsoft Internet Explorer")
                loadIframe('formframe', 'local_eas.jsp');
            else
                document.getElementById('formframe').src = 'local_eas.jsp';
        }

        function loadKeyholders()
        {    
            if(navigator.appName == "Microsoft Internet Explorer")
                loadIframe('formframe', 'keyholders.jsp');
            else
                document.getElementById('formframe').src = 'keyholders.jsp';
        }

        function loadBallots()
        {
            if(navigator.appName == "Microsoft Internet Explorer")
                loadIframe('formframe', 'ballots.jsp');
            else
                document.getElementById('formframe').src = 'ballots.jsp';
        }

        function loadDateAndTime()
        {
            if(navigator.appName == "Microsoft Internet Explorer")
                loadIframe('formframe', 'date_time.jsp');
            else
                document.getElementById('formframe').src = 'date_time.jsp';
        }

        function loadParams()
        {
            if(navigator.appName == "Microsoft Internet Explorer")
                loadIframe('formframe', 'params.jsp');
            else
                document.getElementById('formframe').src = 'params.jsp';
        }

        function loadSecLevel()
        {
            if(navigator.appName == "Microsoft Internet Explorer")
                loadIframe('formframe', 'sec_level.jsp');
            else
                document.getElementById('formframe').src = 'sec_level.jsp';
        }    

        function loadVoteSub()
        {
            if(navigator.appName == "Microsoft Internet Explorer")
                loadIframe('formframe', 'vote_sub.jsp');
            else
                document.getElementById('formframe').src = 'vote_sub.jsp';
        }

        function loadInnerDiv(choice) //loads div with a table which contains 3 choices
        {
            if(choice == 1)//initialization 
            {
                document.getElementById('innerdiv').innerHTML =
                    "<table id='cards' border='1' width='430'  height='320'><thead><tr height='60'>"+
                    "<th><a href='#' onclick='loadCentralEA()'>Central<br>election authority<br>definition</a></th>"+
                    "<th><a href='#' onclick='loadLocalEA()'>Local<br>election authorities<br>definition</a></th>"+                    
                    "<th><a href='#' onclick='loadKeyholders()'>Keyholders<br>definition</a></th>"+
                    "</tr></thead><tr height='260'><td colspan='3'><iframe id='formframe' frameborder = '0'></iframe></td></tr></table>";

                loadCentralEA();
             }
             else if(choice == 2)//parameterization 
             {
                document.getElementById('innerdiv').innerHTML =
                    "<table id='cards' border='1' width='430'  height='320'><thead><tr height='60'>"+  
                    "<th><a href='#' onclick='loadBallots()'>Ballots and candidates</a></th>"+     
                    "<th><a href='#' onclick='loadDateAndTime()'>Date and Time</a></th>"+
                    "<th><a href='#' onclick='loadParams()'>Protocol parameters</a></th>"+
                    "<th><a href='#' onclick='loadSecLevel()'>Security level</a></th>"+
                    "<th><a href='#' onclick='loadVoteSub()'>Vote submission</a></th>"+
                    "</tr></thead><tr height='260'><td colspan='5'><iframe id='formframe' frameborder = '0'></iframe>"+
                    "</td></tr></table>"; 

                    loadBallots();
             }       
             else if(choice == 3)//basic operations 
             {
                document.getElementById('innerdiv').innerHTML = 
                    "<table border='0' width='430'  height='320'>"+  
                    "<tr><td align='center'><a href='#' onclick='loadBasic(1)'><img src='images/buttons/elcatalog.gif'/></a></td></tr>"+
                    "<tr><td align='center'><a href='#' onclick='loadBasic(2)'><img src='images/buttons/start_central_registrar.gif'/><a></td></td></tr>"+
                    "<tr><td align='center'><a href='#' onclick='loadBasic(3)'><img src='images/buttons/activate_keyholders.gif'/><a></td></td></tr>"+
                    "<tr><td align='center'><a href='#' onclick='loadBasic(4)'><img src='images/buttons/starttallying.gif'/><a></td></td></tr>"+
                    "<tr><td><br></td></tr>"+
                    "<tr><td><br></td></tr>"+
                    "<tr><td><br></td></tr>"+
                    "</table>";
             }  
        }

        function loadIframe(iframeName, url)
        {
            if ( window.frames[iframeName] ) 
            {
                window.frames[iframeName].location = url;
                return false;
            }
            else return true;
        }

        function loadBasic(button_number)
        {
            var ural = "";            
            url = "basic_operations.jsp?button_num="+button_number+"&username="+"<%=usr%>"+"&password="+"<%=psw%>";
            window.open(url, 'mywind', 'left=500, top=350, width=440, height=250, toolbar=0, resizable=1, status=0, menubar=0, scrollbars=1')
        }

        </script>
        
    </body>
</html>
