<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" href="../css/forms_style.css"  type="text/css"/>  
        <title>BALLOT INSERTION</title>
        
        <script>            
        function validateCandNum()
        {
            var ret = validateNumber(document.ballot.candidate_number.value);

            if(ret == -1)
                alert("Insert ballots number");
            else if(ret == 0)
                alert("Invalid ballots number");
            else
                loadBallotDiv();
        }
        
        function validateNumber(element) //validates if an element is a positive number
        {
            var digits="0123456789";
            var temp;

            if (element=="")             
                return -1;

            for (var i=0; i < element.length; i++)
            {
                temp=element.substring(i,i+1);
                if (digits.indexOf(temp)==-1)
                    return 0;
            }
            return 1;
        }
        
        function validateBallotWithCands()
        {
            var candidate_number = document.ballot.candidate_number.value;
            var empty_fields = false;
            var invalid_m = false;

            //Check if there are elements that must be completed and are empty
            for (var i=0; i < candidate_number*2; i++) //there are 2 elements for each candidate
            {
                element_name = document.candidate.elements[i].name;

                if( document.candidate.elements[i].value == "" || document.ballot.ballot_description.value == "" || document.ballot.candidate_number.value == "")
                {
                    alert("You must complete all fields");
                    empty_fields = true;
                    break;
                }
            }

            if(empty_fields == false)//check for invalid candidate numbers
            {
                for(var i=0; i < candidate_number*2; i++)
                {
                    element_name = document.candidate.elements[i].name;
                    element_value = document.candidate.elements[i].value;
                    el_name_without_number = element_name.substring(0,(element_name.length-1));

                    if(el_name_without_number == "candidate_m")
                    {
                        if(validateNumber(document.candidate.elements[element_name].value) != 1)
                        {
                            invalid_m = true;
                            break;
                        }  
                    }
                }    

                if(invalid_m == true)
                {
                    alert("Invalid candidate code");
                    return false;
                }
                else
                {
                    document.candidate.submit();
                    return true;           
                }
            }
            else
                return false;
        }
        
        function loadBallotDiv()
        {
            var str="<form name='candidate' action='../actions/store_data.jsp' method='GET'>";
           
            for(var i=1; i<=document.ballot.candidate_number.value; i++)
                str = str+"CANDIDATE (ANSWER)&nbsp;&nbsp;"+i+
                     "<table border='0' >"+
                     "<tr><td align='left'><b>Candidate description </b>:</td><td align='center'><input type='text' style='width: 150px'  name='candidate_description"+i+"' value=''/></td></tr>"+
                     "<tr><td align='left'><b>Candidate code</b>:</td><td align='center'><input type='text'style='width: 150px' name='candidate_m"+i+"' value=''/></td></tr>"+
                     "</table><br>";              

            str = str+"<input type='hidden' value='candidate' name='form_name'/>"+
                      "<input type='hidden' value='"+document.ballot.ballot_description.value+"' name='ballot_description'/>"+
                      "<input type='hidden' value='"+document.ballot.candidate_number.value+"' name='candidate_number'/>"+
                      "<input type='hidden' value='"+document.ballot.vote_area.value+"' name='vote_area'/>"+
                      "</form>";
                                  
            str = str + "<center><a><img onclick='validateBallotWithCands();' src='../images/buttons/insert.gif' /></a>&nbsp;&nbsp;&nbsp;"+
                        "<a><img onclick='window.close(); window.location.reload()' src='../images/buttons/close.gif' /></a></center><br>";
                      
            document.getElementById('cand').innerHTML = str;  
            
        }
        
        </script>
        
    </head>
    <body id="bd">

    
    <%
    String no = request.getParameter("no");    
    
    if(no.equals("1"))//case 1: ballot definition
    {
        %>
        <form name='ballot' onsubmit='return false;'>
        <table border='0' cellspacing='10px'>
            <tr>
                <td align='left'><b>Ballot description </b>:</td>
                <td align='left'><input type='text' style='width: 150px' name='ballot_description' value=''/></td>
            </tr>
            <tr>
                <td align='left'><b>Election authority</b>:</td>
                <td align='left'><input type='text' style='width: 20px' name='vote_area' value=''/></td>
            </tr>
            <tr>
                <td align='left'><b>Candidate number </b>:</td>
                <td align='left'><input onkeyup='validateCandNum();' type='text' style='width: 20px' name='candidate_number' value=''/></td>
            </tr>            
        </table></form><br>
        
        <div id='cand'></div>
        <%
        
    }
    else if(no.equals("2")) //case 2: ballot update
    {
        //String ea_id = request.getParameter("ea_id");
        
        
    }
    else if(no.equals("3")) //case 3: ballot deletion
    {
        //String ea_id = request.getParameter("ea_id");
        
        
    }
    %>
    </body>
</html>
