<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" href="../css/forms_style.css"  type="text/css"/>  
        <title>PROTOCOL PARAMETERS</title>
        <script>   
            function validateParameters()
            {
                var ret = validateNumber(document.protocol_params.threshold.value);

                if(ret == -1)
                {
                    alert("Insert decryption threshold");
                    return false;
                }
                else if(ret == 0)
                {
                    alert("Decryption threshold must be an integer");
                    return false;
                }
                else
                {
                    document.protocol_params.submit();
                    return true;
                }
            }     
            
        function validateNumber(element) //validates if an element is a positive number
        {
            var digits="0123456789";
            var temp;

            if (element=="")             
                return -1;

            for (var i=0; i < element.length; i++)
            {
                temp=element.substring(i,i+1);
                if (digits.indexOf(temp)==-1)
                    return 0;
            }
            return 1;
        }
        </script>
    </head>  
    <body id="bd">
    <%
    String no = request.getParameter("no");    
    
    if(no.equals("1"))//case 1: protocol_params definition
    {
    %>
        
    <form name='protocol_params' action='../actions/store_data.jsp' method='GET'>
        <table border='0' width='400' >
            <tr>
                <td width='350'><b>Zero Knowledge Proof Protocols</b></td><td>
                <input onmousedown='this.isChecked = this.checked;' onclick='this.checked = !this.isChecked;'  type='radio' name='zkp' value='zkp'/></td>
            </tr>
            <tr>
                <td width='350'><b>Digital signatures</b></td><td>
                <input onmousedown='this.isChecked = this.checked;' onclick='this.checked = !this.isChecked;' type='radio' name='signs' value='signs'/></td>
            </tr>
            <tr>
                <td width='350'><b>Timestamping</b></td>
                <td><input onmousedown='this.isChecked = this.checked;' onclick='this.checked = !this.isChecked;' type='radio' name='timestamp' value='timestamp'/></td>
            </tr>
            <tr>
                <td width='350'><b>Key Length</b></td>
                <td><select name='key_length'><option value = '32' selected>32<option value = '64'>64<option value = '128'>128
                <option value = '256'>256<option value = '512'>512<option value = '1024'>1024</select></td>
            </tr>
            <tr>
                <td width='350'><b>Decryption Threshold</b></td>
                <td><input style='width:55px' type='text' name='threshold' value=''/></td>
            </tr>
            <tr>
                <td colspan='2'><br></td>
            </tr>  
            <tr>
               <td colspan='2' align='center'><a><img onclick="validateParameters()" src='../images/buttons/insert.gif' /></a>
               <a><img onclick="window.close(); window.location.reload()" src='../images/buttons/close.gif' /></a></td>
            </tr> 
        </table>
        <input type='hidden' value='protocol_params' name='form_name'/>
    </form>
    
    <%
    }
    else if(no.equals("2")) //case 2: protocol_params defined and can be updated
    {
    %>
      <form name='protocol_params' action='../actions/store_data.jsp' method='GET'>
        <table border='0' width='400' >
            <tr>
                <td width='350'><b>Zero Knowledge Proof Protocols</b></td><td>
                <input onmousedown='this.isChecked = this.checked;' onclick='this.checked = !this.isChecked;'  type='radio' name='zkp' value='zkp'/></td>
            </tr>
            <tr>
                <td width='350'><b>Digital signatures</b></td><td>
                <input onmousedown='this.isChecked = this.checked;' onclick='this.checked = !this.isChecked;' type='radio' name='signs' value='signs'/></td>
            </tr>
            <tr>
                <td width='350'><b>Timestamping</b></td>
                <td><input onmousedown='this.isChecked = this.checked;' onclick='this.checked = !this.isChecked;' type='radio' name='timestamp' value='timestamp'/></td>
            </tr>
            <tr>
                <td width='350'><b>Key Length</b></td>
                <td><select name='key_length'><option value = '32' selected>32<option value = '64'>64<option value = '128'>128
                <option value = '256'>256<option value = '512'>512<option value = '1024'>1024</select></td>
            </tr>
            <tr>
                <td width='350'><b>Decryption Threshold</b></td>
                <td><input style='width:55px' type='text' name='threshold' value=''/></td>
            </tr>
            <tr>
                <td colspan='2'><br></td>
            </tr>  
            <tr>
               <td colspan='2' align='center'><a><img onclick="validateParameters()" src='../images/buttons/update.gif' /></a>
               <a><img onclick="window.close(); window.location.reload()" src='../images/buttons/close.gif' /></a></td>
            </tr> 
        </table>
        <input type='hidden' value='protocol_params' name='form_name'/>
    </form>
    <%
    }
    else if(no.equals("3"))//delete protocol_params
    {
    %>
    <br>
    <center>Do you want to proceed deleting protocol parameters; 
    <form name='protocol_params' action='../actions/delete_data.jsp' method='GET'>
        <table border='0' width='400'>
            <tr>
                <td align="center"><br><a><img onclick="document.protocol_params.submit()" src='../images/buttons/delete.gif' /></a>
                <a><img onclick="window.close(); window.location.reload()" src='../images/buttons/invalid.gif' /></a></td>
            </tr>
        </table>
        <input type='hidden' value='protocol_params' name='form_name'/>
    </form>   
    </center>
    <%        
    }
    %>
   
    </body>
</html>
