<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="org.pnyka.database.*, java.sql.*"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <link rel="stylesheet" href="css/forms_style.css" type="text/css"/>  
    </head>
    <body id="bd">

    <%
    
    Connection conn = null;//database connection
    ResultSet config_security_protocol = null;
    int count_config_security_protocol = 0;
    
    try
    {
        //connection with central database
        conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
        config_security_protocol = DatabaseQueries.selectFromTable(conn, "SELECT * FROM config_security_protocol");
        count_config_security_protocol = DatabaseQueries.countRows(config_security_protocol);
        
        if(count_config_security_protocol != 0)
        {
            config_security_protocol.next();
            if(config_security_protocol.getString("zkp_protocol") == null)
            {
                out.print("<br><br><center>Protocol parameters<br> have not been defined</center><br>");
            %>
            <center><a href= '#' onclick = "window.open('forms/params_form.jsp?no=1', 'mywind', 'left=500, top=350, width=440, height=270, toolbar=0, resizable=1, status=0, menubar=0')">
                    <img class="image" src='images/buttons/insert.gif' />
            </a></center>
            <br>
            <%
            }
            else if(config_security_protocol.getString("zkp_protocol") != null)
            {
                
                String zkp_protocol = (config_security_protocol.getBoolean("zkp_protocol") == false) ? "NO" : "YES";
                String timestamps_protocol = (config_security_protocol.getBoolean("timestamps_protocol") == false) ? "NO" : "YES";
                String signatures_protocol = (config_security_protocol.getBoolean("signatures_protocol") == false) ? "NO" : "YES";
                
                out.print("<div id='data'>");            
                out.print("<b>PROTOCOL PARAMETERS</b><br>");
                out.print("<b>Zero Knowledge Proofs: </b>"+zkp_protocol+"<br>");
                out.print("<b>Timestamping </b>"+timestamps_protocol+"<br>");
                out.print("<b>Digital signatures:</b> "+signatures_protocol+"<br>");
                out.print("<b>Key length:</b> "+config_security_protocol.getString("key_length")+"&nbsp bits<br>");
                out.print("<b>Decryption threshold:</b> "+config_security_protocol.getString("threshold")+"<br>");
                
            %>
            <br>
            <center>
                <a href= '#' onclick = "window.open('forms/params_form.jsp?no=2', 'mywind', 'left=500, top=350, width=440, height=270, scrollbars=1, toolbar=0, resizable=1, status=0, menubar=0')">
                    <img class="image" src='images/buttons/update.gif' />
                </a>
                <a href= '#' onclick = "window.open('forms/params_form.jsp?no=3', 'mywind', 'left=500, top=350, width=440, height=270, scrollbars=1, toolbar=0, resizable=1, status=0, menubar=0')">
                    <img class="image" src='images/buttons/delete.gif' />
                </a>
            </center>
            <%
            out.print("</div>");   
            }
                        
        }
        if(count_config_security_protocol == 0)
        {
            out.print("<br><br><center>Protocol parameters<br> have not been defined</center><br>");
            %>
            <center><a href= '#' onclick = "window.open('forms/params_form.jsp?no=1', 'mywind', 'left=500, top=350, width=440, height=270, toolbar=0, resizable=1, status=0, menubar=0')">
                    <img class="image" src='images/buttons/insert.gif' />
            </a></center>
            <br>
            <%
                        
        }
                
    }
    catch (SQLException e1)
    {
        out.print( e1.toString()+"<br>");
        out.print("<div id='message'>There was a problem during transaction with database.</div>");
    }
    catch (NullPointerException e2)
    {
        out.print( e2.toString()+"<br>");
        out.print("<div id='message'>There was a problem during transaction with database.</div>");
    }
    %>
    
    </body>
</html>
